import numpy as np
import socket

class Perceptron():
    
    def __init__(self):
        # 19 x 1 matrix of weights
        np.random.seed(1)
        self.weights = 2 * np.random.random((19, 1)) - 1

    def sigmoid(self, x):
        return 1 / (1 + np.exp(-x))

    def sigmoid_derivative(self, x):
        return x * (1 - x)

    def train(self, experiences):

        trainIn = []

        file = open("traininginput.txt", "r")
        while True:
            floatList = []
            trainingInput = file.readline()
            if not trainingInput:
                break;
            trainingInput = trainingInput.replace("[","")
            trainingInput = trainingInput.replace("]","")
            trainingInput = trainingInput.replace("'","")
            trainingInput = trainingInput.replace("\n","")
            nums = trainingInput.split(", ")
            for item in nums:
                item = float(item)
                floatList.append(item)
            trainIn.append(floatList)
        trainInFormatted = np.array(trainIn)
        file.close()

        trainOut = []

        file = open("trainingoutput.txt", "r")
        while True:
            floatList = []
            trainingOutput = file.readline()
            if not trainingOutput:
                break
            num = float(trainingOutput)
            floatList.append(num)
            trainOut.append(floatList)
        trainOutFormatted = np.array(trainOut)
        np.transpose(trainOutFormatted)
        file.close()

        print(".")
        print(".")
        print(".")
        print("Exposing neuron to your past experiences.")
        # print(trainInFormatted)
        # print("")
        # print("^^^^^^^^^^^^^^^^^^^^^^^^^")
        # print("^^^^^^^^^^^^^^^^^^^^^^^^^")
        # print("^^^^^^^^^^^^^^^^^^^^^^^^^")
        # print("Training Factors")
        # print(".")
        # print(".")
        # print(".")
        # print(trainOutFormatted)
        # print("")
        # print("^^^^^^^^^^^^^^^^^^^^^^^^^")
        # print("^^^^^^^^^^^^^^^^^^^^^^^^^")
        # print("^^^^^^^^^^^^^^^^^^^^^^^^^")
        # print("Training Outcomes")
        # print(".")
        # print(".")
        # print(".")

        for experience in range(experiences):
            output = self.think(trainInFormatted)
            #print ("OUT:  " + str(output))

            error = trainOutFormatted - output
            #print ("ERR:  " + str(error))

            # Multiply error by input and gradient of the sigmoid function
            # Less confident weights are adjusted more through the nature of the function
            adjustments = np.dot(trainInFormatted.T, error * self.sigmoid_derivative(output))
            #print("ADJUS:  " + str(adjustments))

            self.weights += adjustments

    def think(self, inputs):
        inputs = inputs.astype(float)
        output = self.sigmoid(np.dot(inputs, self.weights))
        #print("DOT PROD OF INPUTS AND WEIGHTS:")
        #print(np.dot(inputs, self.weights))
        #print("OUTPUT (SIGMOID OF DOT PROD):")
        #print(output)
        #print("OUTPUT TYPE:")
        #print(type(output))
        #print("DONE.")
        return output

    def readMode(self):
        file = open("mode.txt", "r")
        mode = file.readlines();
        file.close()
        return mode

    def askFactorsForTraining(self):
        print("For the questions below,")
        print("type 0 for NO or 1 for YES.")
        print("")
        print("")
        A = str(input("Did you consume any caffeine today? "))
        B = str(input("Did you consume any THC today? "))
        C = str(input("Did you consume any alcohol today? "))
        D = str(input("Did you have a strong sense of purpose today? "))
        E = str(input("Did you feel pressed for time today? "))
        F = str(input("Did you rigorously exercise today? "))
        G = str(input("Did you walk a substantial distance today? "))
        H = str(input("Did you keep a phone on your person today? "))
        I = str(input("Did you use a laptop or desktop PC for more than 5 minutes today? "))
        J = str(input("Did you use a television today? "))
        K = str(input("Did you fail at something you were motivated to accomplish today? "))
        L = str(input("Did you fail at something you were unmotivated to accomplish today? "))
        M = str(input("Did you feel angry at any point today? "))
        N = str(input("Did you feel fearful at any point today? "))
        O = str(input("Today, did you feel more at peace with something that previously bothered you? "))
        P = str(input("Did you feel admiration for someone today? "))
        Q = str(input("Did you eat meat today? "))
        R = str(input("Did you eat fruit today? "))
        S = str(input("Did you eat vegetables today? "))

        userInputs = [A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S]

        file = open("traininginput.txt", "a")
        file.write(str(userInputs))
        file.write("\n")
        file.close()

        factorsName = []

        factorsName.append("caffeine")
        factorsName.append("thc")
        factorsName.append("alcohol")
        factorsName.append("purpose")
        factorsName.append("time")
        factorsName.append("exercise")
        factorsName.append("walk")
        factorsName.append("phone")
        factorsName.append("computer")
        factorsName.append("tv")
        factorsName.append("motivatedFail")
        factorsName.append("unmotivatedFail")
        factorsName.append("anger")
        factorsName.append("fear")
        factorsName.append("peace")
        factorsName.append("admire")
        factorsName.append("meat")
        factorsName.append("fruit")
        factorsName.append("veggie")

        # file = open("outcomescores.txt", "r")
        # scores = file.readlines();
        # file.close()
        # outcomeScores = []
        # for score in scores:
        #     score = score.replace("\n", "")
        #     score = int(score)
        #     outcomeScores.append(score)

        file = open("mode.txt", "w+")
        file.write(str("o"))
        file.close()
        print("")
        print("")
        print("")
        print("Come back tomorrow to record outcomes!")
        print("")
        print("")
        print("")
        print("")
        print("")
        print("")

    def askOutcomes(self):
        print("")
        print("")
        print("")

        outcome = 0

        print("")
        print("")
        print("")
        print("For the questions below,")
        print("type 0 for NO or 1 for YES.")
        print("")
        print("")
        healthOutcome = str(input("Are you physically healthy (not sick or aching)?"))
        moodOutcome = str(input("Are you feeling light and vibrant or positive and hopeful?"))
        mindOutcome = str(input("Is your mind clear or calm?"))

        file = open("outcomescores.txt", "r")
        scores = file.readlines();
        file.close()
        outcomeScores = []
        for score in scores:
            score = score.replace("\n", "")
            score = int(score)
            outcomeScores.append(score)

        if healthOutcome=="1":
            outcomeScores[0] = outcomeScores[0] + 1
        if moodOutcome=="1":
            outcomeScores[1] = outcomeScores[1] + 1
        if mindOutcome=="1":
            outcomeScores[2]= outcomeScores[2] + 1

        file = open("outcomescores.txt", "w+")
        file.write(str(outcomeScores[0]))
        file.write("\n")
        file.write(str(outcomeScores[1]))
        file.write("\n")
        file.write(str(outcomeScores[2]))
        file.write("\n")
        file.close()

        isSatisfactory = False;
        if (healthOutcome == 1 and moodOutcome == 1 and mindOutcome == 1):
            isSatisfactory = True

        if isSatisfactory==True:
            outcome = 1

        file = open("trainingoutput.txt", "a")
        file.write(str(outcome))
        file.write("\n")
        file.close()

        file = open("mode.txt", "w+")
        file.write(str("f"))
        file.close()

        print("")
        print("")
        print("")
        print("Thank you for your submission!")
        print("Nobody has access to your submitted data except for you.")
        print("")
        print("")
        print("")

    def askFactorsForPrediction(self):
        # print(".")
        # print(".")
        # print(".")
        # print(analysis.weights)
        # print("")
        # print("")
        # print("^^^^^^^^^^^^^^^^^^^^^^^^^")
        # print("^^^^^^^^^^^^^^^^^^^^^^^^^")
        # print("^^^^^^^^^^^^^^^^^^^^^^^^^")
        # print("")
        # print("Priorities After Learning")
        print(".")
        print(".")
        print(".")
        print("The 19 questions you answered have been")
        print("prioritized by their impact on you.")
        print("_______________________________________")
        print("")
        print("")
        print("")
        print("Answer the 19 questions again, but this time")
        print("for a prediction of your personal state tomorrow!")
        print("")
        print("")
        print("For the questions below,")
        print("type 0 for NO or 1 for YES.")
        print("")
        print("")
        A = str(input("Did you consume any caffeine today? "))
        B = str(input("Did you consume any THC today? "))
        C = str(input("Did you consume any alcohol today? "))
        D = str(input("Did you have a strong sense of purpose today? "))
        E = str(input("Did you feel pressed for time today? "))
        F = str(input("Did you rigorously exercise today? "))
        G = str(input("Did you walk a substantial distance today? "))
        H = str(input("Did you keep a phone on your person today? "))
        I = str(input("Did you use a laptop or desktop PC for more than 5 minutes today? "))
        J = str(input("Did you use a television today? "))
        K = str(input("Did you fail at something you were motivated to accomplish today? "))
        L = str(input("Did you fail at something you were unmotivated to accomplish today? "))
        M = str(input("Did you feel angry at any point today? "))
        N = str(input("Did you feel fearful at any point today? "))
        O = str(input("Today, did you feel more at peace with something that previously bothered you? "))
        P = str(input("Did you feel admiration for someone today? "))
        Q = str(input("Did you eat meat today? "))
        R = str(input("Did you eat fruit today? "))
        S = str(input("Did you eat vegetables today? "))

        userInputs = [A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S]

        print(".")
        print(".")
        print(".")
        print("Today's Experience Sequence: ")
        print(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S)
        print("")
        print("")
        print("")
        prediction = analysis.think(np.array([A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S]))
        predictionFormatted = float(prediction[0])
        print("Wellness Measurement:")
        print(predictionFormatted)
        print("")
        print("Prediction for Tomorrow: ")
        verdictNum = int(round(predictionFormatted))
        verdict = ""
        if verdictNum==0:
            verdict="Low, Chaotic"
        if verdictNum==1:
            verdict="Harmonious, Balanced"
        print(verdict)
        print("")
        file = open("outcomescores.txt", "r")
        scores = file.readlines();
        file.close()
        outcomeScores = []
        for score in scores:
            score = score.replace("\n", "")
            score = int(score)
            outcomeScores.append(score)
        if (outcomeScores[0] > outcomeScores[1]
            and outcomeScores[0] > outcomeScores[2]):
            print("Strong: Health")
        if (outcomeScores[1] > outcomeScores[0]
            and outcomeScores[1] > outcomeScores[2]):
            print("Strong: Mood")
        if (outcomeScores[2] > outcomeScores[0]
            and outcomeScores[2] > outcomeScores[1]):
            print("Strong: Mind")
        print("")
        if (outcomeScores[0] < outcomeScores[1]
            and outcomeScores[0] < outcomeScores[2]):
            print("Weak: Health")
        if (outcomeScores[1] < outcomeScores[0]
            and outcomeScores[1] < outcomeScores[2]):
            print("Weak: Mood")
        if (outcomeScores[2] < outcomeScores[0]
            and outcomeScores[2] < outcomeScores[1]):
            print("Weak: Mind")
        print("")
        file = open("trainingoutput.txt", "r")
        lines = file.readlines()
        numLines = len(lines)
        numDays = numLines * 2
        print("My name is Gemmy and I'm in your computer.")
        print("I lived " + str(numDays) + " days of your life...10,000 times.")
        print("")
        print("To increase the number of days lived, submit more data.")
        print("")
        print("")
        print("")
        print("")

if __name__ == "__main__":

    # Initialize the single neuron neural network
    analysis = Perceptron()
    print(".")
    print(".")
    print(".")
    print("Neuron's dendrites activated.")
    print("_______________________________________")
    #print(analysis.weights)

    # The training set, with 4 examples consisting of 3
    # input values and 1 output value
    #training_inputs = np.array([[0,0,1],
                                #[1,1,1],
                                #[1,0,1],
                                #[0,1,1]])

    #training_outputs = np.array([[0,1,1,0]]).T


    #trainIn = np.array([[1,0,0,1,1,1,0,0,1,0,0,0,0,1,1,1,0,1,0],
    #                    [1,1,0,0,0,0,0,0,0,0,1,0,1,0,1,1,1,1,0],
    #                    [0,0,1,0,0,0,1,1,1,1,1,1,0,0,1,0,0,0,1],
    #                    [1,0,1,1,1,1,1,0,0,1,0,0,1,0,1,0,1,1,1]])
    #
    #trainOut = np.array([[1,0,0,1]]).T

    # Train the neural network
    #analysis.train(trainIn, trainOut, 5000)

    #print("Synaptic weights after training: ")
    #print(analysis.weights)

    print("///////////////////////////////////////////")
    print("///               REALGEMS              ///")
    print("///        (Real-Life Game Stats)       ///")
    print("///                                     ///")
    print("///   Copyright © 2022 Wyatt Naftulin   ///")
    print("///////////////////////////////////////////")
    print("")
    print("")
    print("RealGems provides 2 questionnaires. One is about your life today,")
    print("and the other is about your life tomorrow. By weighing these factors")
    print("and outcomes in your life, RealGem's artificial intelligence (AI)")
    print("can make predictions about your future health and wellness. This AI is")
    print("named Gemmy. Gemmy doesn't just map factors to outcomes; Gemmy reads")
    print("between the lines of your life. That means there is no measurement--")
    print("no strict quantification--rather there is a RANKING OF IMPACT which")
    print("can account for the minutiae of influence on you during your days.")
    print("")
    print("")
    print("")
    submitOrPredict = str(input("Type 0 to submit data or 1 for a prediction: "))
    print("")
    print("")
    print("")

    if submitOrPredict=="0":
        mode = analysis.readMode()
        #print(mode)
        if "f" in mode:
            analysis.askFactorsForTraining()
        else:
            analysis.askOutcomes()
    if submitOrPredict=="1":
        mode = analysis.readMode()
        #print(mode)
        if "f" in mode:
            analysis.train(9000)
            analysis.askFactorsForPrediction()
        else:
            print("A PREDICTION CANNOT BE MADE IF YOU ARE IN THE MIDDLE OF A 2-DAY CYCLE.")
            print("YOU MUST SUBMIT AN OUTCOME (DAY 2) FOR THE PREVIOUS DAY'S QUESTIONS (DAY 1) BEFORE REQUESTING A PREDICTION.")
            print("PLEASE RESTART PROGRAM AND TYPE 0.")
